# TP1 correction 

Principe général: se familiariser avec JavaScript.

On utilise `node` dans la console. C'est un peu aride, mais renforcera un certain nombre d'explication sur JavaScript vue en cours juste avant.

On attaquera JS+HTML&CSS avec le navigateur au TP2.
Pour ceux qui sont motivés la partie bonus de ce TP le permet déjà.

## Exercice 0

1. suivre le tuto de la page du cours, qui est une traduction du tuto suivant :
https://heynode.com/tutorial/install-nodejs-locally-nvm/

2. En cas de soucis utiliser : https://www.jdoodle.com/execute-nodejs-online (le lien est tout en bas de la page du sujet.)

## Exercice 1 : Tutoriel -- Bases du langages */

### Question 1.1
Voir, en plus de la doc MDN
    - https://javascript.info/types#type-typeof
    - https://javascript.info/instanceof
    - https://javascript.info/primitives-methods

> There are 7 primitive types: string, number, bigint, boolean, symbol, null and undefined.
> The typeof operator allows us to see which type is stored in a variable.

### Question 1.2
Il suffit de copier coller dans un interpréteur node.

https://javascript.info/comparison#strict-equality
> A strict equality operator === checks the equality without type conversion.

Pour la deuxième partie de cet exercice, il suffit d'exécuter le fichier `tp1web-12equality.js` comme indiqué

### Question 1.3 
Voir, en plus de la doc MDN


https://javascript.info/object#copying-by-reference
> One of the fundamental differences of objects vs primitives is that they are stored and copied “by reference”.

> Primitive values: strings, numbers, booleans – are assigned/copied “as a whole value”.

### Question 1.4
On définit l'objet javascript suivant dans la console node:

```js
const my_object = {
  x: 42,
  y: "test",
  do: function () {
    console.log(`${this.x} ${this.y}`);
  },
};
```

On l'appelle ensuite : `my_object.do();`.

l'utilisation de this.x permet de s'assurer qu'on utilise bien la variable interne à l'objet.

Pour le console.log(), cette syntaxe aura été vue en cours. 
Il s'agit de [Template Literals](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals) ou template strings.
C'est [plus lisible](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#string_interpolation) quand on sort des cas jouets. 

Et ça permet aussi de préparer les étudiants à l'utilisation de templates dans le navigateur.

## Exercice 2

Voici les 5 fonctions à coder :
_ces boucles ont été vues en cours_

```js
function iterate_array(arr) {
  console.log("for...of");
  for (const o of arr) console.log(o);
}

function iterate_array(arr) {
  console.log("for...in");
  for (const i in arr) console.log(arr[i]);
}

function iterate_array(arr) {
  console.log("for");
  for (let i = 0; i < arr.length; i++) console.log(arr[i]);
}

function iterate_array(arr) {
  console.log("while");
  let i = 0;
  while (i < arr.length) {
    console.log(arr[i]);
    i++;
  }
}
function iterate_array(arr) {
  console.log("forEach");
  arr.forEach((x) => console.log(x));
}
```

Faire coder dans un éditeur puis exécuter le code en appelant le fichier depuis node.

## Exercice 3

Dans l'interpréteur node, le résultat de la fonction s'affiche. Du coup il n'y a pas de `console.log()`.

On va utiliser des [arrows functions](https://javascript.info/arrow-functions-basics) dans cet exercice. 

Cela aura été vu en cours. C'est l'occasion pour les étudiants de tester les deux syntaxes.

Solutions possible :

### Exo 3.1 
On utilise `filter()` qui est fait pour ça: 

```js
function equipeElite(equipe) {
    return equipe
        .filter(pokemon => pokemon.niveau > 12);
}
```

Motiver les étudiants à passe le niveau en paramètre de la fonction.

### Exo 3.2

On utilise `map()`pour parcourir l'equipe avec une approche fonctionelle.
On veut un string en résultat, alors on fait `join()` pour concaténer les éléments du tableau résultant de map dans un seul string.

```js
function presentationEquipe(equipe) {
    return equipe
        .map(pokemon => `${pokemon.nom.toUpperCase()} (Type: ${pokemon.type}) - Niveau ${pokemon.niveau}`)
        .join('\n');
}
```

Il est possible de faire un forEach(), poussez à tester map()


### Exo 3.3

Voici une version avec boucles imbriquées, d'autres options sont possibles. 
Le tableau est créé dynamiquement.

J'imagine que les étudiants commenceront par coder les types de pokemon en dur dans leur code.
C'est ok pour démarrer, puis les encourager à basculer sur une approche générique.

```js
function analyseTypes(equipe) {
    const types = {};
    equipe.forEach(pokemon => {
        const pokemonTypes = pokemon.type.split('/');
        pokemonTypes.forEach(type => {
            types[type] = (types[type] || 0) + 1;
        });
    });
    return types;
}
```
