"use strict";

// Voici une liste de Pokémon avec leurs types et niveaux
const pokemons = [
  // Pokémon de départ et leurs évolutions
  { nom: "Pikachu", type: "électrique", niveau: 15 },
  { nom: "Raichu", type: "électrique", niveau: 28 },
  { nom: "Salamèche", type: "feu", niveau: 12 },
  { nom: "Reptincel", type: "feu", niveau: 25 },
  { nom: "Dracaufeu", type: "feu/vol", niveau: 36 },
  { nom: "Carapuce", type: "eau", niveau: 14 },
  { nom: "Carabaffe", type: "eau", niveau: 26 },
  { nom: "Tortank", type: "eau", niveau: 38 },
  { nom: "Bulbizarre", type: "plante/poison", niveau: 13 },
  { nom: "Herbizarre", type: "plante/poison", niveau: 24 },
  { nom: "Florizarre", type: "plante/poison", niveau: 34 },

  // Pokémon divers avec types variés
  { nom: "Roucool", type: "normal/vol", niveau: 10 },
  { nom: "Roucoups", type: "normal/vol", niveau: 22 },
  { nom: "Sablaireau", type: "sol", niveau: 28 },
  { nom: "Nidoking", type: "poison/sol", niveau: 35 },
  { nom: "Mélofée", type: "fée", niveau: 18 },
  { nom: "Alakazam", type: "psy", niveau: 40 },
  { nom: "Machopeur", type: "combat", niveau: 32 },
  { nom: "Tentacruel", type: "eau/poison", niveau: 30 },
  { nom: "Fantominus", type: "spectre/poison", niveau: 16 },
  { nom: "Onix", type: "roche/sol", niveau: 29 },
  { nom: "Léviator", type: "eau/vol", niveau: 42 },
  { nom: "Dracolosse", type: "dragon/vol", niveau: 45 },
  { nom: "Lokhlass", type: "eau/glace", niveau: 37 },
  { nom: "Magnéton", type: "électrique/acier", niveau: 31 },
];

function tutorial_button() {
  console.debug("[js] tutorial_button");
  return JSON.stringify(my_object);
}

function analyseTypes(equipe) {
  const types = {};
  equipe.forEach((pokemon) => {
    const pokemonTypes = pokemon.type.split("/");
    pokemonTypes.forEach((type) => {
      types[type] = (types[type] || 0) + 1;
    });
  });
  //console.log(types);
  return types;
}

function presentationEquipe(equipe) {
  return equipe
    .map(
      (pokemon) =>
        `${pokemon.nom.toUpperCase()} (Type: ${pokemon.type}) - Niveau ${pokemon.niveau}`,
    )
    .join("\n");
}

function equipeElite(equipe, niveau) {
  return equipe.filter((pokemon) => pokemon.niveau > niveau);
}

function createMenuListener() {
  console.log("createlisteners");

  const equipeItem = document.getElementById("equipeItem");
  equipeItem.addEventListener("click", (e) => {
    console.log(`${JSON.stringify(e)} emmitted`);
    document.getElementById("outputEquipe").innerHTML = presentationEquipe(pokemons);
  });

  const $analyseItem = document.getElementById("analyseItem");
  $analyseItem.onclick = () => {
    console.log(analyseTypes(pokemons));
    document.getElementById("outputAnalyse").innerHTML = JSON.stringify(analyseTypes(pokemons));
  };

  document.getElementById("eliteItem").onclick = () => {
    document.getElementById("outputElite").innerHTML = presentationEquipe(
      equipeElite(pokemons, 24),
    );
  };
}

createMenuListener();
